## 网关通信主控板

### 脑图

![](doc/gateway.png)

### 外设说明

* 分风箱主板通讯：uart2
* 五恒主板通讯：uart3
* mini_gateway_board：uart4
* 调试串口：uart1

### 通讯从站配置

| 模块名称               | 从站地址 | 通讯口   |
|--------------------|------|-------|
| 分风箱主板              | 1~15 | uart2 |
| mini_gateway_board | 1    | uart4 |         | 10   | uart3 |

### 运行逻辑

主板上电后，首先搜索各内机是否存在，如果存在，则读取各内机从站站号，并写入寄存器中；
读取内机信息包括：开关机状态、模式、风速、内机编码、故障码。
轮询mini_gateway_board，读出对应故障码，用于维护和调试；湿度下限：40018，湿度上限：40019。

> 当有任意一台内机开机时，向五恒模块同步开机

### 故障码逻辑

1、读取mini_gateway_board故障码，如果故障码为0，则认为无故障，否则认为有故障，并记录故障码，并写入寄存器40020，40021，40022，40023，40024，40025，40026，40027，40028，40029，40030，40031，40032，40033，40034，40035，40036，40037，40038，40039，40040，40041，40042，40043，40044，40045，40046，40047，40048，40049，40050，40051，40052，40053，40054，对应故障码为0，则表示无故障，对应故障码为1，则表示有故障

### 485通讯协议

| 寄存器地址 | 数据含义        | 访问类型 | 范围值                                                |
|-------|-------------|------|----------------------------------------------------|
| 40001 | 电源状态        | RW   | 0x01: 开;0x00:关                                     |
| 40002 | 当前运行模式      | RW   | 0x00：制冷模式；0x01：制热模式；0x02：除湿模式；0x03：送风模式；0x04：加湿模式； |
| 40003 | 新风风阀模式      | RW   | 0x01：通风模式；0x02新风模式                                 |
| 40004 | 预留          | RW   | 预留                                                 |
| 40005 | 风速档位        | RW   | 1-5：代表一至五档；0x00:停止                                 |
| 40006 | 预留          | RW    | 预留                                                 |
| 40007 | 预留          | R    | 预留                                                 |
| 40008 | 预留          | R    | 预留                                                 |
| 40009 | 预留          | R    | 预留                                                 |
| 40010 | 预留          | R    | 预留                                                 |
| 40011 | 内机1~8状态     | RW   | 右到左按位，1为有，0为无；                                     |
| 40012 | 内机9~16状态    | RW   | 右到左按位，1为有，0为无；                                     |
| 40013 | 预留          | RW   | 预留                                                 |
| 40014 | 预留          | RW   | 预留                                                 |
| 40015 | 预留          | RW   | 预留                                                 |
| 40016 | 设定温度        | R    | 16-30℃                                             |
| 40017 | 预留          | R    | 预留                                                 |
| 40018 | 加湿湿度下限      | R    | 0~100%                                             |
| 40019 | 加湿湿度上限      | R    | 0~100%                                             |
| 40020 | 预留          | R    | 预留                                                 |
| 40021 | 网关485/CAN故障 | R    | 0：无故障；1：有故障；                                       |  
| 40022 | 分风箱485故障    | R    | 0：无故障； 1111 1111：对应内机1~8有故障；                       |
| 40023 | 内机组总故障      | R    | 0：无故障；1：有故障；                                       |
| 40024 | 故障信息        | R    | 0：无故障；1：有故障；                                       |
| 40025 | 故障信息        | R    | 0：无故障；1：有故障；                                       |
| 40026 | 故障信息        | R    | 0：无故障；1：有故障；                                       |
| 40027 | 故障信息        | R    | 0：无故障；1：有故障；                                       |
| 40028 | 故障信息        | R    | 0：无故障；1：有故障；                                       |
| 40029 | 故障信息        | R    | 0：无故障；1：有故障；                                       |


